复制代码 代码如下:
#!/bin/bash
#name: upper_to_lower.sh
#the function is trun uper to lower
#like ABCd to abcd
haveuppernumber()
{
#test if the string have upper number
str="$(echo $1 | tr '[:upper:]' '[:lower:]')"
if [ "$str" != $1 ] ; then #get some problem
echo "[#have upper number,and i well trun them to lower:#]"
return 1 #have upper number
else
return 0 #no upper number
fi
}
if [ $# -ne 1 ] ; then
echo "Usage: $0 <string>" >&2
exit 1
fi
if ! haveuppernumber $1 ; then #when if is 0 it run?
#if [ 0 ] ; then #in shell true return 0 ,false return 1
echo $1 | tr '[:upper:]' '[:lower:]' #it can turn the UPPER number to lower
# echo $1 | tr '[:lower:]' '[:upper:]' #it can turn the lower number to UPPER
else
echo "[#no upper number:#]"
echo $1
fi
exit 0
功能说明:当输入”./upper_to_lower.sh AaBbCcdd“时会先判断输入格式是否正确,然后判断字符串中是否有大写字母如果有显示"[#have upper number,and i well trun them to lower:#]"和转换成小写字母后的字符串;如果没有大写字母显示"[#no upper number:#]"和小写字符串。
然后又试着用c语言实现相同的功能,如下:
复制代码 代码如下:
#include<stdio.h>
#include<stdlib.h>
int haveuppernumber(char *p)
{
char*q=p;
for(;*q!='\0';q++)
{
if(*q>='A'&&*q<='Z')
{
printf("[#have upper number and i will turn them to lower #]\n");
return 1;
}
}
printf("[#no upper number#]\n");
return 0;
}
void turntolower(char *p)
{
for(;*p != '\0';p++)
{
if(*p>='A' && *p<='Z')
{
*p+=' ';
}
}
}
int main(int argc , char *argv[])
{
char *p;
p=argv[1];
if(argc != 2)
{
printf("Usage : %s <string>\n",argv[0]);
exit(-1);
}
if(haveuppernumber(p))
{
turntolower(p);
printf("%s\n",argv[1]);
}
else
{
printf("%s\n",argv[1]);
}
return 0;
}
大写字母,小写
免责声明:本站文章均来自网站采集或用户投稿,网站不提供任何软件下载或自行开发的软件! 如有用户或公司发现本站内容信息存在侵权行为,请邮件告知! 858582#qq.com
RTX 5090要首发 性能要翻倍!三星展示GDDR7显存
三星在GTC上展示了专为下一代游戏GPU设计的GDDR7内存。
首次推出的GDDR7内存模块密度为16GB,每个模块容量为2GB。其速度预设为32 Gbps(PAM3),但也可以降至28 Gbps,以提高产量和初始阶段的整体性能和成本效益。
据三星表示,GDDR7内存的能效将提高20%,同时工作电压仅为1.1V,低于标准的1.2V。通过采用更新的封装材料和优化的电路设计,使得在高速运行时的发热量降低,GDDR7的热阻比GDDR6降低了70%。